Module org.hsqldb
Package org.hsqldb.jdbc

## Class JDBCStatement

- java.lang.Object
- - org.hsqldb.jdbc.JDBCStatement

- All Implemented Interfaces:
    `java.lang.AutoCloseable`, `java.sql.Statement`, `java.sql.Wrapper`

      public class JDBCStatement
      extends java.lang.Object
      implements java.sql.Statement, java.sql.Wrapper

  The object used for executing a static SQL statement and returning the results it produces.

  By default, only one `ResultSet` object per `Statement` object can be open at the same time. Therefore, if the reading of one `ResultSet` object is interleaved with the reading of another, each must have been generated by different `Statement` objects. All execution methods in the `Statement` interface implicitly close a statement's current `ResultSet` object if an open one exists.

  # HSQLDB-Specific Information:

  From version 2.0, the implementation meets the JDBC specification requirement that any existing ResultSet is closed when execute() or executeQuery() methods are called. The connection property close_result=true is required for this behaviour.

  Methods added in JAVA 8 are generally supported when the HSQLDB jar is compiled with JDK 8.

  (fredt@users)
  (campbell-burnet@users)

  Since:
    HSQLDB 1.9.0
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
  See Also:
    `JDBCConnection.createStatement()`, `JDBCResultSet`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `RETURN_PRIMARY_KEYS` |

    - ### Fields inherited from interface java.sql.Statement

      `CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addBatch​(java.lang.String sql)` | Adds the given SQL command to the current list of commands for this `Statement` object.
    `void` | `cancel()` | Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
    `void` | `clearBatch()` | Empties this `Statement` object's current list of SQL commands.
    `void` | `clearWarnings()` | Clears all the warnings reported on this `Statement` object.
    `void` | `close()` | Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
    `void` | `closeOnCompletion()` | Specifies that this `Statement` will be closed when all its dependent result sets are closed.
    `boolean` | `execute​(java.lang.String sql)` | Executes the given SQL statement, which may return multiple results.
    `boolean` | `execute​(java.lang.String sql, int autoGeneratedKeys)` | Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
    `boolean` | `execute​(java.lang.String sql, int[] columnIndexes)` | Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `boolean` | `execute​(java.lang.String sql, java.lang.String[] columnNames)` | Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `int[]` | `executeBatch()` | Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
    `long[]` | `executeLargeBatch()` | Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
    `long` | `executeLargeUpdate​(java.lang.String sql)` | Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
    `long` | `executeLargeUpdate​(java.lang.String sql, int autoGeneratedKeys)` | Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
    `long` | `executeLargeUpdate​(java.lang.String sql, int[] columnIndexes)` | Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `long` | `executeLargeUpdate​(java.lang.String sql, java.lang.String[] columnNames)` | Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `java.sql.ResultSet` | `executeQuery​(java.lang.String sql)` | Executes the given SQL statement, which returns a single `ResultSet` object.
    `int` | `executeUpdate​(java.lang.String sql)` | Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
    `int` | `executeUpdate​(java.lang.String sql, int autoGeneratedKeys)` | Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
    `int` | `executeUpdate​(java.lang.String sql, int[] columnIndexes)` | Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `int` | `executeUpdate​(java.lang.String sql, java.lang.String[] columnNames)` | Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `java.sql.Connection` | `getConnection()` | Retrieves the `Connection` object that produced this `Statement` object.
    `int` | `getFetchDirection()` | Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
    `int` | `getFetchSize()` | Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
    `java.sql.ResultSet` | `getGeneratedKeys()` | Retrieves any auto-generated keys created as a result of executing this `Statement` object.
    `long` | `getLargeMaxRows()` | Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
    `long` | `getLargeUpdateCount()` | Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
    `int` | `getMaxFieldSize()` | Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
    `int` | `getMaxRows()` | Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
    `boolean` | `getMoreResults()` | Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
    `boolean` | `getMoreResults​(int current)` | Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
    `int` | `getQueryTimeout()` | Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
    `java.sql.ResultSet` | `getResultSet()` | Retrieves the current result as a `ResultSet` object.
    `int` | `getResultSetConcurrency()` | Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
    `int` | `getResultSetHoldability()` | Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
    `int` | `getResultSetType()` | Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
    `int` | `getUpdateCount()` | Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
    `java.sql.SQLWarning` | `getWarnings()` | Retrieves the first warning reported by calls on this `Statement` object.
    `boolean` | `isClosed()` | Retrieves whether this `Statement` object has been closed.
    `boolean` | `isCloseOnCompletion()` | Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
    `boolean` | `isPoolable()` | Returns a value indicating whether the `Statement` is poolable or not.
    `boolean` | `isWrapperFor​(java.lang.Class<?> iface)` | Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
    `void` | `setCursorName​(java.lang.String name)` | Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
    `void` | `setEscapeProcessing​(boolean enable)` | Sets escape processing on or off.
    `void` | `setFetchDirection​(int direction)` | Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
    `void` | `setFetchSize​(int rows)` | (JDBC4 clarification:) Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement`.
    `void` | `setLargeMaxRows​(long max)` | Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
    `void` | `setMaxFieldSize​(int max)` | (JDBC4 clarification:) Sets the limit for the maximum number of bytes in a `ResultSet` Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
    `void` | `setMaxRows​(int max)` | (JDBC4 clarification:) Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
    `void` | `setPoolable​(boolean poolable)` | Requests that a `Statement` be pooled or not pooled.
    `void` | `setQueryTimeout​(int seconds)` | Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.
    `<T> T` | `unwrap​(java.lang.Class<T> iface)` | Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.sql.Statement

      `closeOnCompletion, enquoteIdentifier, enquoteLiteral, enquoteNCharLiteral, isCloseOnCompletion, isSimpleIdentifier`

- - ### Field Detail

    - #### RETURN_PRIMARY_KEYS

          public static final int RETURN_PRIMARY_KEYS

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### executeQuery

          public java.sql.ResultSet executeQuery​(java.lang.String sql)
                                          throws java.sql.SQLException

      Executes the given SQL statement, which returns a single `ResultSet` object.

      # HSQLDB-Specific Information:

      This method should not be used for statements other than SELECT queries.

      From 2.0, HSQLDB throws an exception when the statement is a DDL statement or an UPDATE or DELETE statement.

      Specified by:
        `executeQuery` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL statement to be sent to the database, typically a static SQL `SELECT` statement
      Returns:
        a `ResultSet` object that contains the data produced by the given query; never `null`
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the given SQL statement produces anything other than a single `ResultSet` object

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql)
                            throws java.sql.SQLException

      Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - (JDBC4 clarification:) an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
      Returns:
        (JDBC4 clarification:) either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the given SQL statement produces a `ResultSet` object

    - #### close

          public void close()
                     throws java.sql.SQLException

      Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources.

      Calling the method `close` on a `Statement` object that is already closed has no effect.

      Note:When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed. (JDBC4 deleted:) [A `Statement` object is automatically closed when it is garbage collected.]

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getMaxFieldSize

          public int getMaxFieldSize()
                              throws java.sql.SQLException

      Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, (JDBC4 new:) `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

      # HSQLDB-Specific Information:

      Including 1.7.2, HSQLDB always returns zero, meaning there is no limit.

      Specified by:
        `getMaxFieldSize` in interface `java.sql.Statement`
      Returns:
        the current column size limit for columns storing character and binary values; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `setMaxFieldSize(int)`

    - #### setMaxFieldSize

          public void setMaxFieldSize​(int max)
                               throws java.sql.SQLException

      (JDBC4 clarification:) Sets the limit for the maximum number of bytes in a `ResultSet` Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, (JDBC4 new:) `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.

      # HSQLDB-Specific Information:

      To present, calls to this method are simply ignored; HSQLDB always stores the full number of bytes when dealing with any of the field types mentioned above. These types all have an absolute maximum element upper bound determined by the Java array index limit java.lang.Integer.MAX_VALUE. For XXXBINARY types, this translates to Integer.MAX_VALUE bytes. For XXXCHAR types, this translates to 2 * Integer.MAX_VALUE bytes (2 bytes / character).

      In practice, field sizes are limited to values much smaller than the absolute maximum element upper bound, in particular due to limits imposed on the maximum available Java heap memory.

      Specified by:
        `setMaxFieldSize` in interface `java.sql.Statement`
      Parameters:
        `max` - the new column size limit in bytes; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
      See Also:
        `getMaxFieldSize()`

    - #### getMaxRows

          public int getMaxRows()
                         throws java.sql.SQLException

      Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.
      Specified by:
        `getMaxRows` in interface `java.sql.Statement`
      Returns:
        the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `setMaxRows(int)`

    - #### setMaxRows

          public void setMaxRows​(int max)
                          throws java.sql.SQLException

      (JDBC4 clarification:) Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.
      Specified by:
        `setMaxRows` in interface `java.sql.Statement`
      Parameters:
        `max` - the new max rows limit; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
      See Also:
        `getMaxRows()`

    - #### setEscapeProcessing

          public void setEscapeProcessing​(boolean enable)
                                   throws java.sql.SQLException

      Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL statement to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for `PreparedStatements` objects will have no effect.
      Specified by:
        `setEscapeProcessing` in interface `java.sql.Statement`
      Parameters:
        `enable` - `true` to enable escape processing; `false` to disable it
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`

    - #### getQueryTimeout

          public int getQueryTimeout()
                              throws java.sql.SQLException

      Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

      # HSQLDB-Specific Information:

      To present, HSQLDB always returns zero, meaning there is no limit.

      Specified by:
        `getQueryTimeout` in interface `java.sql.Statement`
      Returns:
        the current query timeout limit in seconds; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `setQueryTimeout(int)`

    - #### setQueryTimeout

          public void setQueryTimeout​(int seconds)
                               throws java.sql.SQLException

      Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown. A JDBC (JDBC4 clarification:) driver must apply this limit to the `execute`, `executeQuery` and `executeUpdate` methods. JDBC driver implementations may also apply this limit to `ResultSet` methods (consult your driver vendor documentation for details).

      # HSQLDB-Specific Information:

      The maximum number of seconds to wait is 32767.

      Specified by:
        `setQueryTimeout` in interface `java.sql.Statement`
      Parameters:
        `seconds` - the new query timeout limit in seconds; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `seconds >= 0` is not satisfied
      See Also:
        `getQueryTimeout()`

    - #### cancel

          public void cancel()
                      throws java.sql.SQLException

      Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

      # HSQLDB-Specific Information:

      HSQLDB version 2.3.4 and later supports aborting an SQL query or data update statement.

      Specified by:
        `cancel` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

    - #### getWarnings

          public java.sql.SQLWarning getWarnings()
                                          throws java.sql.SQLException

      Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

      The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

      Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

      # HSQLDB-Specific Information:

      In 2.0, HSQLDB may produces Statement warnings; this method always returns null.

      Specified by:
        `getWarnings` in interface `java.sql.Statement`
      Returns:
        the first `SQLWarning` object or `null` if there are no warnings
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`

    - #### clearWarnings

          public void clearWarnings()
                             throws java.sql.SQLException

      Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

      # HSQLDB-Specific Information:

      In HSQLDB 2.0, `SQLWarning` objects may be produced for Statement Objects; calls to this method clear the warnings.

      Specified by:
        `clearWarnings` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`

    - #### setCursorName

          public void setCursorName​(java.lang.String name)
                             throws java.sql.SQLException

      Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To insure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

      Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

      # HSQLDB-Specific Information:

      Including 2.0, HSQLDB does not support named cursors; calls to this method are ignored.

      Specified by:
        `setCursorName` in interface `java.sql.Statement`
      Parameters:
        `name` - the new cursor name, which must be unique within a connection
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

    - #### execute

          public boolean execute​(java.lang.String sql)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results. In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
      Returns:
        `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

    - #### getResultSet

          public java.sql.ResultSet getResultSet()
                                          throws java.sql.SQLException

      Retrieves the current result as a `ResultSet` object. This method should be called only once per result.

      # HSQLDB-Specific Information:

      Specified by:
        `getResultSet` in interface `java.sql.Statement`
      Returns:
        the current result as a `ResultSet` object or `null` if the result is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `execute(java.lang.String)`

    - #### getUpdateCount

          public int getUpdateCount()
                             throws java.sql.SQLException

      Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.
      Specified by:
        `getUpdateCount` in interface `java.sql.Statement`
      Returns:
        the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `execute(java.lang.String)`

    - #### getMoreResults

          public boolean getMoreResults()
                                 throws java.sql.SQLException

      Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.

      There are no more results when the following is true:

               // stmt is a Statement object
               ((stmt.getMoreResults() == false) && (stmt.getUpdateCount() == -1))

      Specified by:
        `getMoreResults` in interface `java.sql.Statement`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `execute(java.lang.String)`

    - #### setFetchDirection

          public void setFetchDirection​(int direction)
                                 throws java.sql.SQLException

      Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

      Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

      # HSQLDB-Specific Information:

      HSQLDB accepts all valid parameters.

      Specified by:
        `setFetchDirection` in interface `java.sql.Statement`
      Parameters:
        `direction` - the initial direction for processing rows
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the given direction is not one of `ResultSet.FETCH_FORWARD`, `ResultSet.FETCH_REVERSE`, or `ResultSet.FETCH_UNKNOWN`
      Since:
        JDK 1.2
      See Also:
        `getFetchDirection()`

    - #### getFetchDirection

          public int getFetchDirection()
                                throws java.sql.SQLException

      Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

      # HSQLDB-Specific Information:

      HSQLDB returns the fetch direction.

      Specified by:
        `getFetchDirection` in interface `java.sql.Statement`
      Returns:
        the default fetch direction for result sets generated from this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2
      See Also:
        `setFetchDirection(int)`

    - #### setFetchSize

          public void setFetchSize​(int rows)
                            throws java.sql.SQLException

      (JDBC4 clarification:) Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement`. If the value specified is zero, then the hint is ignored. The default value is zero.

      # HSQLDB-Specific Information:

      HSQLDB uses the specified value as a hint, but may process more or fewer rows than specified.

      Specified by:
        `setFetchSize` in interface `java.sql.Statement`
      Parameters:
        `rows` - the number of rows to fetch
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the (JDBC4 modified:) condition `rows >= 0` is not satisfied.
      Since:
        JDK 1.2
      See Also:
        `getFetchSize()`

    - #### getFetchSize

          public int getFetchSize()
                           throws java.sql.SQLException

      Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.
      HSQLDB-Specific Information

      HSQLDB returns 0 by default, or the fetch size specified by setFetchSize

      Specified by:
        `getFetchSize` in interface `java.sql.Statement`
      Returns:
        the default fetch size for result sets generated from this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2
      See Also:
        `setFetchSize(int)`

    - #### getResultSetConcurrency

          public int getResultSetConcurrency()
                                      throws java.sql.SQLException

      Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

      # HSQLDB-Specific Information:

      HSQLDB supports `CONCUR_READ_ONLY` and `CONCUR_UPDATABLE` concurrency.

      Specified by:
        `getResultSetConcurrency` in interface `java.sql.Statement`
      Returns:
        either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2

    - #### getResultSetType

          public int getResultSetType()
                               throws java.sql.SQLException

      Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

      # HSQLDB-Specific Information:

      HSQLDB 1.7.0 and later versions support `TYPE_FORWARD_ONLY` and `TYPE_SCROLL_INSENSITIVE`.

      Specified by:
        `getResultSetType` in interface `java.sql.Statement`
      Returns:
        one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2

    - #### addBatch

          public void addBatch​(java.lang.String sql)
                        throws java.sql.SQLException

      Adds the given SQL command to the current list of commands for this `Statement` object. The commands in this list can be executed as a batch by calling the method `executeBatch`.

      (JDBC4 clarification:)

      NOTE: Support of an ability to batch updates is optional.

      # HSQLDB-Specific Information:

      Starting with 1.7.2, this feature is supported.

      Specified by:
        `addBatch` in interface `java.sql.Statement`
      Parameters:
        `sql` - typically this is a SQL `INSERT` or `UPDATE` statement (:JDBC4 modified)
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
      Since:
        JDK 1.2
      See Also:
        `executeBatch()`

    - #### clearBatch

          public void clearBatch()
                          throws java.sql.SQLException

      Empties this `Statement` object's current list of SQL commands.

      (JDBC4 clarification:)

      NOTE: Support of an ability to batch updates is optional.

      # HSQLDB-Specific Information:

      Starting with HSQLDB 1.7.2, this feature is supported.

      Specified by:
        `clearBatch` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
      Since:
        JDK 1.2
      See Also:
        `addBatch(java.lang.String)`

    - #### executeBatch

          public int[] executeBatch()
                             throws java.sql.SQLException

      Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:
      1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
      2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

         If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

      3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

      (JDBC4 clarification:)

      NOTE: Support of an ability to batch updates is optional.

      The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to process commands in a batch update after a `BatchUpdateException` object has been thrown.

      # HSQLDB-Specific Information:

      Starting with HSQLDB 1.7.2, this feature is supported.

      HSQLDB stops execution of commands in a batch when one of the commands results in an exception. The size of the returned array equals the number of commands that were executed successfully.

      Specified by:
        `executeBatch` in interface `java.sql.Statement`
      Returns:
        an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
      Since:
        JDK 1.3
      See Also:
        `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

    - #### getConnection

          public java.sql.Connection getConnection()
                                            throws java.sql.SQLException

      Retrieves the `Connection` object that produced this `Statement` object.
      Specified by:
        `getConnection` in interface `java.sql.Statement`
      Returns:
        the connection that produced this statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2

    - #### getMoreResults

          public boolean getMoreResults​(int current)
                                 throws java.sql.SQLException

      Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.

      There are no more results when the following is true:

               // stmt is a Statement object
               ((stmt.getMoreResults(current) == false) && (stmt.getUpdateCount() == -1))

      # HSQLDB-Specific Information:

      HSQLDB moves to the next ResultSet and returns the correct result.

      Specified by:
        `getMoreResults` in interface `java.sql.Statement`
      Parameters:
        `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSet`: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the argument supplied is not one of the following: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
      Since:
        JDK 1.4, HSQLDB 1.7
      See Also:
        `execute(java.lang.String)`

    - #### getGeneratedKeys

          public java.sql.ResultSet getGeneratedKeys()
                                              throws java.sql.SQLException

      Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

      (JDBC4 clarification:)

      Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

      # HSQLDB-Specific Information:

      Starting with version 2.0, HSQLDB supports this feature with single-row and multi-row insert, update and merge statements.

      This method returns a result set only if the executeUpdate methods that was used is one of the three methods that have the extra parameter indicating return of generated keys

      If the executeUdate method did not specify the columns which represent the auto-generated keys the IDENTITY column or GENERATED column(s) of the table are returned.

      The executeUpdate methods with column indexes or column names return the post-insert or post-update values of the specified columns, whether the columns are generated or not. This allows values that have been modified by execution of triggers to be returned.

      If column names or indexes provided by the user in the executeUpdate() method calls do not correspond to table columns (incorrect names or indexes larger than the column count), an empty result is returned.

      Specified by:
        `getGeneratedKeys` in interface `java.sql.Statement`
      Returns:
        a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql,
                                   int autoGeneratedKeys)
                            throws java.sql.SQLException

      Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      # HSQLDB-Specific Information:

      Starting with version 2.0, HSQLDB supports returning generated columns with single-row and multi-row INSERT, UPDATE and MERGE statements.

      If the table has an IDENTITY or GENERATED column(s) the values for these columns are returned in the next call to getGeneratedKeys(). HSQLDB also supports returning primary key values from the rows by using the `org.hsqldb.jdbc.JDBCStatement.RETURN_PRIMARY_KEYS` constant.

      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement. (:JDBC4 clarification)
        `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing (:JDBC4 clarification)
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement returns a `ResultSet` object, or the given constant is not one of those allowed
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql,
                                   int[] columnIndexes)
                            throws java.sql.SQLException

      Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return (JDBC 4 clarification) auto-generated keys (the list of such statements is vendor-specific).

      # HSQLDB-Specific Information:

      Starting with version 2.0, HSQLDB supports returning generated columns with single-row and multi-row INSERT, UPDATE and MERGE statements.

      The columnIndexes may specify any set of columns of the table.

      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement. (:JDBC4 clarification)
        `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing (:JDBC 4 clarification)
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, or the second argument supplied to this method is not an `int` array whose elements are valid column indexes
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql,
                                   java.lang.String[] columnNames)
                            throws java.sql.SQLException

      Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. The driver will ignore the array if the SQL statement (JDBC4 clarification:) is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      # HSQLDB-Specific Information:

      Starting with version 2.0, HSQLDB supports returning generated columns with single-row and multi-row INSERT, UPDATE and MERGE statements.

      The columnNames may specify any set of columns of the table.

      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement. (:JDBC4 clarification)
        `columnNames` - an array of the names of the columns that should be returned from the inserted row
      Returns:
        either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, or the second argument supplied to this method is not a `String` array whose elements are valid column names
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### execute

          public boolean execute​(java.lang.String sql,
                                 int autoGeneratedKeys)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement, or an SQL statement able to return (JDBC4 clarification) auto-generated keys (the list of such statements is vendor-specific).

      In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      # HSQLDB-Specific Information:

      Starting with 2.0, HSQLDB supports this feature. HSQLDB also supports returning primary key values from the rows by using the `org.hsqldb.result.ResultConstants.RETURN_PRIMARY_KEYS` constant.

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
        `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
      Returns:
        `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the second parameter supplied to this method is not `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`.
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
      Since:
        JDK 1.4, HSQLDB 1.7
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

    - #### execute

          public boolean execute​(java.lang.String sql,
                                 int[] columnIndexes)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement (JDBC4 clarification) is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      # HSQLDB-Specific Information:

      Starting with 2.0, HSQLDB supports this feature.

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
        `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
      Returns:
        `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements in the `int` array passed to this method are not valid column indexes
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

    - #### execute

          public boolean execute​(java.lang.String sql,
                                 java.lang.String[] columnNames)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      # HSQLDB-Specific Information:

      Starting with 2.0, HSQLDB supports this feature.

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
        `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements of the `String` array passed to this method are not valid column names
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

    - #### getResultSetHoldability

          public int getResultSetHoldability()
                                      throws java.sql.SQLException

      Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
      Specified by:
        `getResultSetHoldability` in interface `java.sql.Statement`
      Returns:
        either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### isClosed

          public boolean isClosed()
                           throws java.sql.SQLException

      Retrieves whether this `Statement` object has been closed. A `Statement` is closed if the method close has been called on it, or if it is automatically closed.
      Specified by:
        `isClosed` in interface `java.sql.Statement`
      Returns:
        true if this `Statement` object is closed; false if it is still open
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setPoolable

          public void setPoolable​(boolean poolable)
                           throws java.sql.SQLException

      Requests that a `Statement` be pooled or not pooled. The value specified is a hint to the statement pool implementation indicating whether the application wants the statement to be pooled. It is up to the statement pool manager as to whether the hint is used.

      The poolable value of a statement is applicable to both internal statement caches implemented by the driver and external statement caches implemented by application servers and other applications.

      By default, a `Statement` is not poolable when created, and a `PreparedStatement` and `CallableStatement` are poolable when created.

      Specified by:
        `setPoolable` in interface `java.sql.Statement`
      Parameters:
        `poolable` - requests that the statement be pooled if true and that the statement not be pooled if false

      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`

      Since:
        JDK 1.6 Build 81, HSQLDB 2.0

    - #### isPoolable

          public boolean isPoolable()
                             throws java.sql.SQLException

      Returns a value indicating whether the `Statement` is poolable or not.

      Specified by:
        `isPoolable` in interface `java.sql.Statement`
      Returns:
        `true` if the `Statement` is poolable; `false` otherwise
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`

      Since:
        JDK 1.6 Build 81, HSQLDB 2.0

      See Also:
        `setPoolable(boolean)`

    - #### unwrap

          public <T> T unwrap​(java.lang.Class<T> iface)
                       throws java.sql.SQLException

      Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.
      Specified by:
        `unwrap` in interface `java.sql.Wrapper`
      Parameters:
        `iface` - A Class defining an interface that the result must implement.
      Returns:
        an object that implements the interface. May be a proxy for the actual implementing object.
      Throws:
        `java.sql.SQLException` - If no object found that implements the interface
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### isWrapperFor

          public boolean isWrapperFor​(java.lang.Class<?> iface)
                               throws java.sql.SQLException

      Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.
      Specified by:
        `isWrapperFor` in interface `java.sql.Wrapper`
      Parameters:
        `iface` - a Class defining an interface.
      Returns:
        true if this implements the interface or directly or indirectly wraps an object that does.
      Throws:
        `java.sql.SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getLargeUpdateCount

          public long getLargeUpdateCount()
                                   throws java.sql.SQLException

      Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      The public implementation will throw `UnsupportedOperationException`

      Specified by:
        `getLargeUpdateCount` in interface `java.sql.Statement`
      Returns:
        the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        1.8
      See Also:
        `execute(java.lang.String)`

    - #### setLargeMaxRows

          public void setLargeMaxRows​(long max)
                               throws java.sql.SQLException

      Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

      This method should be used when the row limit may exceed `Integer.MAX_VALUE`.

      The default implementation will throw `UnsupportedOperationException`

      Specified by:
        `setLargeMaxRows` in interface `java.sql.Statement`
      Parameters:
        `max` - the new max rows limit; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
      Since:
        1.8
      See Also:
        `getMaxRows()`

    - #### getLargeMaxRows

          public long getLargeMaxRows()
                               throws java.sql.SQLException

      Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

      This method should be used when the returned row limit may exceed `Integer.MAX_VALUE`.

      The default implementation will return `0`

      Specified by:
        `getLargeMaxRows` in interface `java.sql.Statement`
      Returns:
        the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        1.8
      See Also:
        `setMaxRows(int)`

    - #### executeLargeBatch

          public long[] executeLargeBatch()
                                   throws java.sql.SQLException

      Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `long` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeLargeBatch` may be one of the following:
      1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
      2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

         If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getLargeUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

      3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      The default implementation will throw `UnsupportedOperationException`

      Specified by:
        `executeLargeBatch` in interface `java.sql.Statement`
      Returns:
        an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8
      See Also:
        `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

    - #### executeLargeUpdate

          public long executeLargeUpdate​(java.lang.String sql)
                                  throws java.sql.SQLException

      Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

      The default implementation will throw `UnsupportedOperationException`

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement produces a `ResultSet` object, the method is called on a `PreparedStatement` or `CallableStatement`
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8

    - #### executeLargeUpdate

          public long executeLargeUpdate​(java.lang.String sql,
                                         int autoGeneratedKeys)
                                  throws java.sql.SQLException

      Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

      The default implementation will throw `SQLFeatureNotSupportedException`

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
        `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement returns a `ResultSet` object, the given constant is not one of those allowed, the method is called on a `PreparedStatement` or `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8

    - #### executeLargeUpdate

          public long executeLargeUpdate​(java.lang.String sql,
                                         int[] columnIndexes)
                                  throws java.sql.SQLException

      Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

      The default implementation will throw `SQLFeatureNotSupportedException`

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
        `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object,the second argument supplied to this method is not an `int` array whose elements are valid column indexes, the method is called on a `PreparedStatement` or `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8

    - #### executeLargeUpdate

          public long executeLargeUpdate​(java.lang.String sql,
                                         java.lang.String[] columnNames)
                                  throws java.sql.SQLException

      Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

      The default implementation will throw `SQLFeatureNotSupportedException`

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
        `columnNames` - an array of the names of the columns that should be returned from the inserted row
      Returns:
        either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, the second argument supplied to this method is not a `String` array whose elements are valid column names, the method is called on a `PreparedStatement` or `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8

    - #### closeOnCompletion

          public void closeOnCompletion()
                                 throws java.sql.SQLException

      Specifies that this `Statement` will be closed when all its dependent result sets are closed. If execution of the `Statement` does not produce any result sets, this method has no effect.

      Note: Multiple calls to `closeOnCompletion` do not toggle the effect on this `Statement`. However, a call to `closeOnCompletion` does effect both the subsequent execution of statements, and statements that currently have open, dependent, result sets.

      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`
      Since:
        JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1

    - #### isCloseOnCompletion

          public boolean isCloseOnCompletion()
                                      throws java.sql.SQLException

      Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
      Returns:
        `true` if the `Statement` will be closed when all of its dependent result sets are closed; `false` otherwise
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`
      Since:
        JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1